/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: TimerHandleDelegate.java 12246 2007-12-09 21:42:38Z benoitf $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.ejb;

import javax.ejb.Timer;


/**
 * Interface implemented by the Delegate used to retrieve Timers from TimerHandles.
 * @author durieuxp
 */
public interface TimerHandleDelegate {

    /**
     * Retrieve A Timer from its info.
     * @param infos
     * @return the Timer
     */
    public Timer getTimer(JTimerHandleInfo info);

    /**
     * Restart A Timer retrieved by its info.
     * @param infos
     * @return the Timer restarted
     */
    public Timer restartTimer(JTimerHandleInfo info);
}
