package org.ow2.jonas.webapp.jonasadmin.monitoring;

import java.io.IOException;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.ow2.jonas.webapp.jonasadmin.JonasBaseAction;
import org.ow2.jonas.webapp.jonasadmin.JonasManagementRepr;
import org.ow2.jonas.webapp.jonasadmin.WhereAreYou;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * This action display all inormations on JOnAS server.
 * @author eyindanga.
 *
 */
public class DisplayNodeInfoAction extends JonasBaseAction {

    /* (non-Javadoc).
     * @see org.ow2.jonas.webapp.jonasadmin.JonasBaseAction#executeAction(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    public ActionForward executeAction(final ActionMapping p_Mapping,
            ActionForm p_Form, final HttpServletRequest p_Request,
            HttpServletResponse p_Response) throws IOException,
            ServletException {
        // Form used
        WhereAreYou oWhere = (WhereAreYou) p_Request.getSession().getAttribute(
                WhereAreYou.SESSION_NAME);
        String sDomainName = oWhere.getCurrentDomainName();

        String serverName = oWhere.getCurrentJonasServerName();

        NodeInfoForm oForm = (NodeInfoForm) p_Form;
        try {

            /*
             * Server related info
             */
            //  oForm.setServerName(p_Request.getParameter("node"));
            oForm.setServerName(serverName);
            ObjectName on = new ObjectName(sDomainName
                    + ":type=ServerProxy,name=" + oForm.getServerName());
            try {
                oForm.setState((String) JonasManagementRepr.getAttribute(on,
                        "State", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setState("Unavailable");
            }
            try {
                oForm.setHostName((String) JonasManagementRepr.getAttribute(on,
                        "HostName", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setHostName("Unavailable");
            }
            try {
                oForm.setAllThreadsCount((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "AllThreadsCount", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setAllThreadsCount(-1);
            }
            try {
                oForm.setJavaVersion((String) JonasManagementRepr.getAttribute(on,
                        "JavaVersion", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setJavaVersion("Unavailable");
            }
            try {
                oForm.setJavaVendor((String) JonasManagementRepr.getAttribute(on,
                        "JavaVendor", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setJavaVendor("Unavailable");
            }
            try {
                oForm.setCurrentTotalMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentTotalMemory", serverName).toString())
                .intValue());
            } catch (RuntimeException e) {
                oForm.setCurrentTotalMemory(-1);
            }
            try {
                oForm.setCurrentUsedMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentUsedMemory", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
                 oForm.setCurrentUsedMemory(-1);
            }
            try {
                oForm.setJOnASVersion((String) JonasManagementRepr.getAttribute(on,
                        "JOnASVersion", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setJOnASVersion(null);
            }
            try {
                oForm.setProtocols((String) JonasManagementRepr.getAttribute(on,
                        "Protocols", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setProtocols(null);
            }
            try {
                oForm.setConnectionUrl((String) JonasManagementRepr.getAttribute(on,
                        "ConnectionUrl", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setConnectionUrl(null);
            }
            /*
             * JDK5
             */

            /*
             * Tomcat
             */
            try {
                oForm.setTomcat(getBooleanAttribute(on, "Tomcat"));
                if (oForm.getTomcat()) {
                    oForm.setMaxThreadsByConnectorTomcat(getIntegerAttribute(on, "MaxThreadsByConnectorTomcat"));
                    oForm.setCurrentThreadCountByConnectorTomcat(getIntegerAttribute(on, "CurrentThreadCountByConnectorTomcat"));
                    oForm.setCurrentThreadBusyByConnectorTomcat(getIntegerAttribute(on, "CurrentThreadBusyByConnectorTomcat"));
                    oForm.setBytesReceivedByConnectorTomcat(getLongAttribute(on, "BytesReceivedByConnectorTomcat"));
                    oForm.setBytesSentByConnectorTomcat(getLongAttribute(on, "BytesSentByConnectorTomcat"));
                    oForm.setErrorCountByConnectorTomcat(getIntegerAttribute(on, "ErrorCountByConnectorTomcat"));
                    oForm.setProcessingTimeByConnectorTomcat(getLongAttribute(on, "ProcessingTimeByConnectorTomcat"));
                    oForm.setRequestCountByConnectorTomcat(getIntegerAttribute(on, "RequestCountByConnectorTomcat"));
                }
            } catch (RuntimeException e) {
                // Attibute missing
                 oForm.setMaxThreadsByConnectorTomcat(-1);
                 oForm.setCurrentThreadCountByConnectorTomcat(-1);
                 oForm.setCurrentThreadBusyByConnectorTomcat(-1);
                 oForm.setBytesReceivedByConnectorTomcat(-1);
                 oForm.setBytesSentByConnectorTomcat(-1);
                 oForm.setErrorCountByConnectorTomcat(-1);
                 oForm.setProcessingTimeByConnectorTomcat(-1);
                 oForm.setRequestCountByConnectorTomcat(-1);
            }
            /*
             * Tx
             */
            try {
                oForm.setTransaction(getBooleanAttribute(on, "Transaction"));
                if (oForm.getTransaction()) {
                    oForm.setTotalBegunTransactions(getIntegerAttribute(on, "TotalBegunTransactions"));
                    oForm.setTotalCommittedTransactions(getIntegerAttribute(on, "TotalCommittedTransactions"));
                    oForm.setTotalCurrentTransactions(getIntegerAttribute(on, "TotalCurrentTransactions"));
                    oForm.setTotalExpiredTransactions(getIntegerAttribute(on, "TotalExpiredTransactions"));
                    oForm.setTotalRolledbackTransactions(getIntegerAttribute(on, "TotalExpiredTransactions"));
                }
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setTotalBegunTransactions(-1);
                oForm.setTotalCommittedTransactions(-1);
                oForm.setTotalCurrentTransactions(-1);
                oForm.setTotalExpiredTransactions(-1);
                oForm.setTotalRolledbackTransactions(-1);

            }
            /*
             * Worker Pool
             */
            try {
                oForm.setWorkers(getBooleanAttribute(on, "Workers"));
                if (oForm.getWorkers()) {
                    oForm.setCurrentWorkerPoolSize(getIntegerAttribute(on, "CurrentWorkerPoolSize"));
                    oForm.setMaxWorkerPoolSize(getIntegerAttribute(on, "MaxWorkerPoolSize"));
                    oForm.setMinWorkerPoolSize(getIntegerAttribute(on, "MinWorkerPoolSize"));
                }
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setCurrentWorkerPoolSize(-1);
                oForm.setMaxWorkerPoolSize(-1);
                oForm.setMinWorkerPoolSize(-1);
            }
            /*
             * JCA
             */
            try {
                oForm.setJcaConnection(getBooleanAttribute(on, "JcaConnection"));
                if (oForm.getJcaConnection()) {
                    oForm.setConnectionFailuresJCAConnection(getIntegerAttribute(on, "ConnectionFailuresJCAConnection"));
                    oForm.setConnectionLeaksJCAConnection(getIntegerAttribute(on, "ConnectionLeaksJCAConnection"));
                    oForm.setCurrentBusyJCAConnection(getIntegerAttribute(on, "CurrentBusyJCAConnection"));
                    oForm.setCurrentOpenedJCAConnection(getIntegerAttribute(on, "CurrentOpenedJCAConnection"));
                    oForm.setRejectedOpenJCAConnection(getIntegerAttribute(on, "RejectedOpenJCAConnection"));
                    oForm.setServedOpenJCAConnection(getIntegerAttribute(on, "ServedOpenJCAConnection"));
                    oForm.setWaiterCountJCAConnection(getIntegerAttribute(on, "WaiterCountJCAConnection"));
                    oForm.setWaitingTimeJCAConnection(getLongAttribute(on, "WaitingTimeJCAConnection"));
                }
            } catch (Exception e) {
                // Attibute missing
                oForm.setConnectionFailuresJCAConnection(-1);
                oForm.setConnectionLeaksJCAConnection(-1);
                oForm.setCurrentBusyJCAConnection(-1);
                oForm.setCurrentOpenedJCAConnection(-1);
                oForm.setRejectedOpenJCAConnection(-1);
                oForm.setServedOpenJCAConnection(-1);
                oForm.setWaiterCountJCAConnection(-1);
                oForm.setWaitingTimeJCAConnection(-1);
            }
            /*
             * JDBC
             */
            try {
                oForm.setJdbcDatasource(getBooleanAttribute(on, "JdbcDatasource"));
                if (oForm.getJdbcDatasource()) {
                    oForm.setConnectionFailuresJDBCDatasource(getIntegerAttribute(on, "ConnectionFailuresJDBCResource"));
                    oForm.setConnectionLeaksJDBCDatasource(getIntegerAttribute(on, "ConnectionLeaksJDBCResource"));
                    oForm.setCurrentBusyJDBCDatasource(getIntegerAttribute(on, "CurrentBusyJDBCResource"));
                    oForm.setCurrentOpenedJDBCDatasource(getIntegerAttribute(on, "CurrentOpenedJDBCResource"));
                    oForm.setRejectedOpenJDBCDatasource(getIntegerAttribute(on, "RejectedOpenJDBCResource"));
                    oForm.setServedOpenJDBCDatasource(getIntegerAttribute(on, "ServedOpenJDBCResource"));
                    oForm.setWaiterCountJDBCDatasource(getIntegerAttribute(on, "WaiterCountJDBCResource"));
                    oForm.setWaitingTimeJDBCDatasource(getLongAttribute(on, "WaitingTimeJDBCResource"));
                }
            } catch (RuntimeException e) {
                // Attibute missing
                oForm.setConnectionFailuresJDBCDatasource(-1);
                oForm.setConnectionLeaksJDBCDatasource(-1);
                oForm.setCurrentBusyJDBCDatasource(-1);
                oForm.setCurrentOpenedJDBCDatasource(-1);
                oForm.setRejectedOpenJDBCDatasource(-1);
                oForm.setServedOpenJDBCDatasource(-1);
                oForm.setWaiterCountJDBCDatasource(-1);
                oForm.setWaitingTimeJDBCDatasource(-1);
            }
            /*
             * JMS
             */
            try {
                oForm.setJmsJoram(getBooleanAttribute(on, "JmsJoram"));
                if (oForm.getJmsJoram()) {
                    oForm.setJmsQueuesNbMsgsDeliverSinceCreation(getIntegerAttribute(on, "JmsQueuesNbMsgsDeliverSinceCreation"));
                    oForm.setJmsQueuesNbMsgsReceiveSinceCreation(getIntegerAttribute(on, "JmsQueuesNbMsgsReceiveSinceCreation"));
                    int jmsQueuesNbMsgsSendToDMQSinceCreation = getIntegerAttribute(on, "JmsQueuesNbMsgsSendToDMQSinceCreation");
                    oForm.setJmsQueuesNbMsgsSendToDMQSinceCreation(jmsQueuesNbMsgsSendToDMQSinceCreation);

                    oForm.setJmsTopicsNbMsgsDeliverSinceCreation(getIntegerAttribute(on, "JmsTopicsNbMsgsDeliverSinceCreation"));
                    oForm.setJmsTopicsNbMsgsReceiveSinceCreation(getIntegerAttribute(on, "JmsTopicsNbMsgsReceiveSinceCreation"));
                    int jmsTopicsNbMsgsSendToDMQSinceCreation = getIntegerAttribute(on, "JmsTopicsNbMsgsSendToDMQSinceCreation");
                    oForm.setJmsTopicsNbMsgsSendToDMQSinceCreation(jmsTopicsNbMsgsSendToDMQSinceCreation);
                    oForm.setJmsNbMsgsSendToDMQSinceCreation(jmsQueuesNbMsgsSendToDMQSinceCreation + jmsTopicsNbMsgsSendToDMQSinceCreation);
                }
            } catch (RuntimeException e) {
                // Attibute missing
                 oForm.setJmsQueuesNbMsgsDeliverSinceCreation(-1);
                 oForm.setJmsQueuesNbMsgsReceiveSinceCreation(-1);
                 int jmsQueuesNbMsgsSendToDMQSinceCreation = -1;
                 oForm.setJmsQueuesNbMsgsSendToDMQSinceCreation(-1);

                 oForm.setJmsTopicsNbMsgsDeliverSinceCreation(-1);
                 oForm.setJmsTopicsNbMsgsReceiveSinceCreation(-1);
                 int jmsTopicsNbMsgsSendToDMQSinceCreation = -1;
                 oForm.setJmsTopicsNbMsgsSendToDMQSinceCreation(-1);
                 oForm.setJmsNbMsgsSendToDMQSinceCreation(-1);
            }
            /*
             * EJB
             */
            try {
                oForm.setCurrentNumberOfEJB(getIntegerAttribute(on, "CurrentNumberOfEJB"));
                oForm.setCurrentNumberOfEntity(getIntegerAttribute(on, "CurrentNumberOfEntityBean"));
                oForm.setCurrentNumberOfMDB(getIntegerAttribute(on, "CurrentNumberOfMDB"));
                oForm.setCurrentNumberOfSBF(getIntegerAttribute(on, "CurrentNumberOfSBF"));
                oForm.setCurrentNumberOfSBL(getIntegerAttribute(on, "CurrentNumberOfSBL"));
            } catch (RuntimeException e) {
                // Attibute missing
                 oForm.setCurrentNumberOfEJB(-1);
                 oForm.setCurrentNumberOfEntity(-1);
                 oForm.setCurrentNumberOfMDB(-1);
                 oForm.setCurrentNumberOfSBF(-1);
                 oForm.setCurrentNumberOfSBL(-1);
            }

        } catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }

        // Forward to the jsp.
        return (p_Mapping.findForward("DisplayNode"));
    }
}
